'The ATTiny13 is used.

                           ' generated. Take care that the chip supports all fuse bytes.
$regfile = "ATtiny13.dat"
$crystal = 9600000
$hwstack = 8
$swstack = 8
$framesize = 8

'PB1:       0=Gleise abschalten  1=Gleise einschalten
'PB2:       0=Kurzschluss detektiert
'PB3:       Relais schalten
'PB4:       LED ein/aus

Config Portb.4 = Output
Config Portb.3 = Output
Config Portb.1 = Output

Config Pinb.2 = Input                                       'input immer pinx.x
Portb.2 = 1                                                 'pullup

Gleis Alias Portb.1
Relais Alias Portb.3
Led Alias Portb.4

Kurzer Alias Pinb.2                                         ' eingang mit pullup

Dim Status As Integer
Dim Zaehler As Integer
Dim I As Integer


For I = 0 To 4                                              '4 mal blinken beim Einschalten
   Led = Not Led
   Waitms 200
Next

Status = 0
Led = 0
Gleis = 1
I = 0



Do
   If Kurzer = 0 Then
      Waitus 50                                             'Kurzschluss muss mindestens 50us bestehen, damit ausgelst wird
      If Kurzer = 0 Then Gosub Umschalten                   'sonst flackert das Ganze -> Kurzschluss detektiert
   End If
   Gosub Zuruecksetzen

Loop

Umschalten:
   Gleis = 0                                                'Gleisstrom Unterbrechen
   Led = 1                                                  'LED einschalten
   If Status = 0 Then
      Relais = Not Relais                                   'Relais umschalten
      Waitms 3                                              '13ms warten zum Umschalten des Relais - hngt vom Relais ab zu lang fr manche decoder neues relay mit 3 ms
      Status = 1
                                       'Erster Kurzschluss gefunden
   Else
      I = 0
      Waitms 50                                             'immernoch kurzer zeit verlngern Kurzschluss muss mindestens 1 Sekunde weg sein, damit Releais wieder schaltet                                                 '500ms warten, erst dann wieder Pfuus auf's Gleis, ohne Relais
   End If
   Gleis = 1                                                'Wieder Strom  auf's Gleis geben
Return

Zuruecksetzen:                                              ' warten
  If Status = 1 Then
     Waitus 50
     Incr I
     If I >= 10 Then
         Status = 0
         Led = 0
         I = 0
     End If
  End If
Return